"{ Package: 'jv:smallsense' }"

"{ NameSpace: SmallSense }"

AbstractSearchDialog subclass:#PackageSearchDialog
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SmallSense-Core-Interface-Search'
!

!PackageSearchDialog methodsFor:'queries'!

canSelect:selection
    ^ selection askFor: #isSmallSensePackagePO

    "Created: / 05-05-2014 / 23:50:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!PackageSearchDialog methodsFor:'searching'!

matchingObjectPOsFor:objects

    objects sort: [ :a :b | a < b ].
    ^ objects collect:[ :e | PackagePO new name: e ].

    "Created: / 05-05-2014 / 23:54:17 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

matchingObjectsForPattern:pattern inEnvironment:environment
    | packages |

    packages := Set new.
    environment allClassesDo: [ :cls |
        | pkg |

        pkg := cls package.
        ((pkg notNil and:[ pkg ~~ PackageId noProjectID ])
            and:[(filter isNil or:[ filter value: pkg ])
            and:[pattern isNil or:[pattern match: pkg]]]) ifTrue:[ packages add: pkg ].
    ].
    environment allMethodsDo:[ :mth |
        | pkg |

        pkg := mth package.
        ((pkg notNil and:[ pkg ~~ PackageId noProjectID ])
            and:[(filter isNil or:[ filter value: pkg ])
            and:[pattern isNil or:[pattern match: pkg]]]) ifTrue:[ packages add: pkg ].
    ].
    ^ packages asArray.

    "Created: / 05-05-2014 / 23:53:04 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

